﻿using System;
using System.Data;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

/// <summary>
/// Summary description for ModelFacade
/// </summary>
public class ModelFacade
{
    public ModelFacade()
    {
        //
        // TODO: Add constructor logic here
        //
    }

    public Claim createClaim(ClaimFormDTO dto)
    {
        // get the policy number and look for a matching policy in the database
        int policyNumber = Int32.Parse(dto.PolicyNumber);
        PolicyDAO policyDAO = new PolicyDAO();
        Policy policy = policyDAO.getPolicyByNumber(policyNumber);
        if (policy == null)
            return null;
        // if we find a match, create a Claim and link it to the policy  
        // we must set up the relationship between Claim and Policy
        // before attempting to generate the reference, because the 
        // ReferenceGenerator uses properties from both classes
        Claim claim = new Claim();

        // link the two objects
        claim.Policy = policy;
        claim.PolicyID = policy.PolicyID;
        claim.Amount = dto.ClaimAmount;
        claim.Description = dto.ClaimDescription;
        claim.DateOfClaim = DateTime.Now;
        claim.IsApproved = false;
        ReferenceGenerator generator = new ReferenceGenerator();
        String reference = generator.getReference(claim);
        claim.Reference = reference;
        // write the claim to the database
        ClaimDAO claimDAO = new ClaimDAO();
        claimDAO.saveClaim(claim);
        // return the claim, associated with the policy
        return claim;
    }

    public List<Claim> getClaims(String whereClause)
    {
        ClaimDAO myDAO = getClaimDAO();
        List<Claim> claimCollection = myDAO.getClaimList(whereClause);
        return claimCollection;
    }

    public List<Claim> getClaims()
    {
        ClaimDAO myDAO = getClaimDAO();
        List<Claim> claimCollection = myDAO.getClaimList();
        return claimCollection;
    }

    public Claim getClaimByRef(String reference)
    {
        ClaimDAO myDAO = getClaimDAO();
        return myDAO.getClaimByRef(reference);
    }

    public void updateClaim(Claim claim)
    {
        ClaimDAO myDAO = getClaimDAO();
        myDAO.updateClaim(claim);
    }

    public Policy getPolicyByNumber(int policyNumber)
    {
        PolicyDAO myDAO = getPolicyDAO();
        Policy myDTO = myDAO.getPolicyByNumber(policyNumber);
        return myDTO;
    }

    private ClaimDAO getClaimDAO()
    {
        ClaimDAO myDAO = new ClaimDAO();
        return myDAO;
    }
    private PolicyDAO getPolicyDAO()
    {
        PolicyDAO myDAO = new PolicyDAO();
        return myDAO;
    }
}
